<?php

session_start();
header("Cache-control: private");

// check the database has been configured
if (!file_exists("emailer_config.php"))
  header("Location: emailer_install.php");

require("emailer_config.php");
$email_sent = false;
$incorrect_password = false;
$result = "";

if (logged_in())
{
  if (isset($_POST['send_email']))
    $result = send_emails();
  else if (isset($_POST['send_test_email']))
    $result = send_test_email();
  else if (isset($_POST['edit_user']))
    edit_user();
  else if (isset($_POST['add_user']))
    add_user();
  else if (isset($_GET['delete']))
    delete_user();
}


/*------------------------------------------------------------------------------------------------*\
  Function:    add_user
  Description: adds a user to the DB.
\*------------------------------------------------------------------------------------------------*/
function add_user()
{
  $first_name = addslashes($_POST['first_name']);
  $last_name  = addslashes($_POST['last_name']);
  $email      = addslashes($_POST['email']);

  $link = db_connect();
  
  mysql_query("
    INSERT INTO webpage_emailer (first_name, last_name, email)
    VALUES ('$first_name', '$last_name', '$email')
      ");

  db_disconnect($link);
}


/*------------------------------------------------------------------------------------------------*\
  Function:    edit_user
  Description: edits a user.
\*------------------------------------------------------------------------------------------------*/
function edit_user()
{
  $first_name = addslashes($_POST['first_name']);
  $last_name  = addslashes($_POST['last_name']);
  $email      = $_POST['email'];
  $id         = $_POST['edit_id'];
 
  $link = db_connect();
  
  mysql_query("
    UPDATE webpage_emailer 
    SET    first_name = '$first_name',
           last_name  = '$last_name',
           email      = '$email'
    WHERE  id = $id
      ");

  db_disconnect($link);
}


/*------------------------------------------------------------------------------------------------*\
  Function:    delete_user
  Description: deletes a user from the DB.
\*------------------------------------------------------------------------------------------------*/
function delete_user()
{
  $link = db_connect();
  $id = $_GET['id'];

  mysql_query("
    DELETE FROM webpage_emailer WHERE id=$id
      ");

  db_disconnect($link);
}


/*------------------------------------------------------------------------------------------------*\
  Function:    get_users
  Description: gets all users in the DB ordered by last name.
\*------------------------------------------------------------------------------------------------*/
function get_users()
{
  $link = db_connect();
  
  $query = mysql_query("
    SELECT * 
    FROM   webpage_emailer
    ORDER BY last_name
      ");

  db_disconnect($link);
  
  return $query;
}


/*------------------------------------------------------------------------------------------------*\
  Function:    db_connect
  Description: connects to a database. After connecting, you should always call disconnect_db() to 
               close it when you're done.
\*------------------------------------------------------------------------------------------------*/
function db_connect()
{
  global $db_hostname, $db_username, $db_password, $db_name;

  $link = @mysql_connect($db_hostname, $db_username, $db_password)
    or die("Couldn't connect to database.");
  @mysql_select_db($db_name) 
    or die ("couldn't find database '$db_name'.");

  return $link;
}


/*------------------------------------------------------------------------------------------------*\
  Function:    db_disconnect
  Description: disconnects from a database
\*------------------------------------------------------------------------------------------------*/
function db_disconnect($link)
{
  @mysql_close($link);
}


/*------------------------------------------------------------------------------------------------*\
  Function:    send_emails
\*------------------------------------------------------------------------------------------------*/
function send_emails()
{
  global $from_address, $reply_to_address, $email_sent;

  $url   = $_POST['url'];
  $email = $_POST['email'];
  $email_subject = $_POST['email_subject'];
	
  $content = _get_page_content($url);
  if (!$content)
    return false;

	$url_info = parse_url($url);

  // if a / is found after the 10th character, (rules out the // in, for example, https://), 
  // then strip off the final "/filename.html" leaving the baseurl. Otherwise, the $url is the 
  // root URL of a site
  if (strpos($url, "/", 10))
  	$base_url = preg_replace("/\/[^\/]*$/", "", $url); // 
  else
  	$base_url = $url;

	$content = _convert_relatives_to_absolutes($content, $base_url);

  // now build the email
  $boundary = md5(time());
  $subject = (!empty($email_subject)) ? $email_subject : "Webpage: $url";

  // determine the end of line character (based on OS)
  $eol = "\n";
  if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN'))
    $eol = "\r\n";
  else if (strtoupper(substr(PHP_OS, 0, 3) == 'MAC'))
    $eol = "\r";
	
  $headers = "MIME-Version: 1.0$eol"
           . "From: Email Webpage Script <$from_address>$eol"
           . "Reply-to: Email Webpage Script <$reply_to_address>$eol";
           
  $headers .= "Content-type: text/html; charset=iso-8859-1$eol";
  $headers .= $content;

  // send it to all users  
  $users = get_users();
  while ($user = mysql_fetch_assoc($users))
  {
    $email = $user['email'];
  	if (mail($email, $subject, "", $headers))
      $email_sent = true;
  }
}


/*------------------------------------------------------------------------------------------------*\
  Function:    send_test_email
\*------------------------------------------------------------------------------------------------*/
function send_test_email()
{
  global $from_address, $reply_to_address, $email_sent;
  
  $url   = $_POST['url'];
  $email = $_POST['test_email'];
  $email_subject = $_POST['email_subject'];

  $content = _get_page_content($url);
  if (!$content)
    return false;
	
	$url_info = parse_url($url);

  // if a / is found after the 10th character, (rules out the // in, for example, https://), 
  // then strip off the final "/filename.html" leaving the baseurl. Otherwise, the $url is the 
  // root URL of a site
  if (strpos($url, "/", 10))
  	$base_url = preg_replace("/\/[^\/]*$/", "", $url);
  else
  	$base_url = $url;

	$content = _convert_relatives_to_absolutes($content, $base_url);

  // now build the email
  $boundary = md5(time());
  $subject = (!empty($email_subject)) ? $email_subject : "Webpage: $url";

  // determine the end of line character (based on OS)
  $eol = "\n";
  if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN'))
    $eol = "\r\n";
  else if (strtoupper(substr(PHP_OS, 0, 3) == 'MAC'))
    $eol = "\r";
	
  $headers = "MIME-Version: 1.0$eol"
           . "From: Email Webpage Script <$from_address>$eol"
           . "Reply-to: Email Webpage Script <$reply_to_address>$eol";
           
  $headers .= "Content-type: text/html; charset=iso-8859-1$eol";
  $headers .= $content;

 	if (mail($email, $subject, "", $headers))
    $email_sent = true;
}


// helper function to retrieve the raw page content from a URL 
function _get_page_content($url)
{
  $filepointer = @fopen($url, "r");

  if ($filepointer)
  {
    while(!feof($filepointer))
  	{
      $buffer = fgets($filepointer, 4096);
      $file .= $buffer;
    }
    fclose($filepointer);
  }   
  else
    return false;

	return $file;
}


function _convert_relatives_to_absolutes($content, $base_url)
{
  $needles = array('href="', 'src="', 'background="');
  $new_txt = '';

  if (substr($base_url,-1) != '/') 
	  $base_url .= '/';

  $new_base_url = $base_url;
  $base_url_parts = parse_url($base_url);

  foreach ($needles as $needle)
	{
    while ($pos = strpos($content, $needle))
		{
      $pos += strlen($needle);
      if (substr($content, $pos, 7) != 'http://' && substr($content, $pos, 8) != 'https://' 
       && substr($content, $pos, 6) != 'ftp://' && substr($content, $pos, 9) != 'mailto://')
			{
        if (substr($content, $pos, 1) == '/') 
				  $new_base_url = $base_url_parts['scheme'].'://'.$base_url_parts['host'];

        $new_txt .= substr($content, 0, $pos).$new_base_url;
      } 
			else {
        $new_txt .= substr($content, 0, $pos);
      }
      $content = substr($content, $pos);
    }
    $content = $new_txt.$content;
    $new_txt = '';
  }

  return $content;
} 


function logged_in()
{
  global $login_password, $incorrect_password;

  if ($_SESSION['logged_in'] == "yes")
    return true;

  else if (isset($_POST['password']))
  {   
    if ($_POST['password'] == $login_password)
    {
      $_SESSION['logged_in'] = "yes";
      return true;
    }
    else
    {
      $incorrect_password = true;
      return false;
    }
  }
}


if (logged_in())
  $users = get_users();

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html>
<head>
<title>Webpage Emailer Script</title>

  <link type="text/css" rel="stylesheet" href="library/styles.css">

<style type="text/css">
p, table, td, tr {
  font-family: arial; 
  font-size: 8pt;
}
input, button, select {
  font-family: arial;
  font-size: 8pt;
}
.title {
  color: white; 
  font-size: 16pt;
}
.notify { 
  border: 1px solid #336699;
  background-color: #ffffee;
  color: #336699;
  padding: 8px;
  width: 500px;
}
.error { 
  border: 1px solid #cc0000;
  background-color: #ffffee;
  color: #cc0000;
  padding: 8px;
  width: 500px;
}
.heading_1 {
  color: #336699;
  font-weight: bold;
}
.list_table {
  border: 1px solid #dddddd;
  width: 100%;
}
.list_table td {
  border: 1px solid #efefef;
}
.edit {
  background-color: #D6E7F0;
}
.delete {
  background-color: #dddddd;
}

</style>

<script type="text/javascript">

function show_add_user()
{
  document.getElementById("add_user").style.display = "block";
  document.getElementById("edit_user").style.display = "none";
  document.getElementById("add_user_button").style.display = "none";
}

function edit_user(first_name, last_name, email, edit_id)
{
  document.getElementById("edit_id").value = edit_id;
  document.getElementById("edit_first_name").value = first_name;
  document.getElementById("edit_last_name").value = last_name;
  document.getElementById("edit_email").value = email;

  document.getElementById("add_user").style.display = "none";
  document.getElementById("edit_user").style.display = "block";
}

</script>

</head>
<body bgcolor='#efefee' leftmargin='0' topmargin='0' marginheight='0' marginwidth='0'>

<table width='100%' bgcolor='#336699' height='50'>
<tr>
  <td class='title'>&nbsp;&nbsp;<b>Webpage Emailer Script</b></td>
</tr>
</table>

<br />
<br />

<table width='600' align='center' bgcolor='white' style='border: 1px solid #666666;' cellpadding='10'>
<tr>
  <td>

    <?php
    
    if (logged_in())
    {
  		if ($email_sent)
  		{
  		  echo "<p class='notify'>Your email has been sent.</p>";
  		}
      else if ($result === false)
      {
  		  echo "<p class='error'>A page at that URL could not be found.</p>";      
      }
      
		?>

	  <p>
		  Please enter the URL of the webpage you wish to send and your email address, then 
			click "SEND EMAIL". To confirm you are sending the correct URL, you may wish 
			to enter your email address in the "Test Email" field and send it to yourself first.
	  </p>

    <form action="<?=$_SERVER['PHP_SELF']?>" method="post">

  		<table>
  		<tr>
  		  <td width="80"><b>Email Subject</b></td>
  			<td><input type="text" name="email_subject" size="70" value="<?php echo $_POST['email_subject']; ?>" /></td>
        <td></td>
  		</tr>
  		<tr>
  		  <td width="80"><b>URL</b></td>
  			<td><input type="text" name="url" size="70" value="<?php echo $_POST['url']; ?>" /></td>
        <td><input type='submit' name="send_email" style="font-weight: bold;" value='Send Email' /></td>
  		</tr>
  		<tr>
  		  <td><b>Test Email</b></td>
  			<td colspan="2">
          <input type="text" name="test_email" size="20" value="<?php echo $_POST['test_email']; ?>" />
          <input type='submit' name="send_test_email" value='Send Test Email' /></td>
  		</tr>
      </table>

    </form>
  
    <hr size="1" />

    <p class="heading_1">Mailing List</p>

    <table cellpadding="1" cellspacing="1" class="list_table">
    <?php
    while ($user = mysql_fetch_assoc($users))
    {
      $id         = $user['id'];
      $first_name = $user['first_name'];
      $last_name  = $user['last_name'];
      $clean_first_name = stripslashes($user['first_name']);
      $clean_last_name  = stripslashes($user['last_name']);
      $email      = $user['email'];

      echo "<tr>
              <td>$clean_first_name</td>
              <td>$clean_last_name</td>
              <td><a href='mailto:$email'>$email</a></td>
              <td width='60' class='edit' align='center'><a href='#' onclick=\"edit_user('$first_name','$last_name','$email', '$id')\">EDIT</a></td>
              <td width='60' class='delete' align='center'><a href='{$_SERVER['PHP_SELF']}?delete=1&id=$id'>DELETE</a></td>
            </tr>";
    }
    ?>
    </table>

    <div id="add_user_button">
      <p>    
        <input type="button" value="Add User" onclick="show_add_user()" />
      </p>
    </div>

    <br />
    
    <div id="add_user" class="notify" style="display: none;">
    
      <form action="<?=$_SERVER['PHP_SELF']?>?action=add" method="post">

        <table>
        <tr>
          <td width="120">First Name</td>
          <td><input type="text" name="first_name" /></td>
        </tr>
        <tr>
          <td>Last Name</td>
          <td><input type="text" name="last_name" /></td>
        </tr>
        <tr>
          <td>Email</td>
          <td><input type="text" name="email" /></td>
        </tr>
        </table>

        <p>
          <input type="submit" name="add_user" value="Add" />
        </p>

      </form>

    </div>


    <div id="edit_user" class="notify" style="display: none;">

      <form action="<?=$_SERVER['PHP_SELF']?>?action=edit" method="post">
        <input type="hidden" name="edit_id" id="edit_id" value="" />

        <table>
        <tr>
          <td width="120">First Name</td>
          <td><input type="text" name="first_name" id="edit_first_name" value="" /></td>
        </tr>
        <tr>
          <td>Last Name</td>
          <td><input type="text" name="last_name" id="edit_last_name" value="" /></td>
        </tr>
        <tr>
          <td>Email</td>
          <td><input type="text" name="email" id="edit_email" value="" /></td>
        </tr>
        </table>

        <p>
          <input type="submit" name="edit_user" value="Edit" />
        </p>

      </form>

    </div>

    <?php
    }
    else
    {
    ?>
    
      <p><b>Please log in</b></p>
      
      <?php
      
      if ($incorrect_password)
      {
  		  echo "<p class='error'>That password is incorrect.</p>";      
      }
      
      ?>
      
      <form action="<?=$_SERVER['PHP_SELF']?>?action=edit" method="post">
        <table>
        <tr>
          <td width="80">Password</td>
          <td><input type="password" name="password" /></td>
          <td><input type="submit" value="LOGIN" /></td>
        </tr>
        </table>
        <br />

      </form>
          
    <?php
    }
    ?>
        
  </td>
</tr>
</table>

</body>
</html>
